<template>
  <Form @submit="onSubmit" :validation-schema="schema" v-slot="{ setFieldValue, values }">
    <b-card no-body class="mb-0 table-card table-hover table-custom-striped p-1">
      <b-row class="form-card">
        {{ currentValue(values) }}
        <b-col cols="12" md="6" class="">
          <b-form-group
            label="Ingredients Category ID"
            label-for="ingredients_category_id"
          >
            <b-form-input
              :disabled="pageType == 'view'"
              id="ingredients_category_id"
              readonly
              placeholder="Auto Generated"
              v-model="IngredientsCategoryModel.ingredients_category_id"
            />
          </b-form-group>
        </b-col>
        <b-col cols="12" md="6" class="">
          <TextInput
            ref="firstInput"
            name="name"
            label="Ingredients Category Name"
            type="text"
            placeholder="Enter Ingredients Category Name"
            v-model="IngredientsCategoryModel.name"
            :disabled="pageType == 'view'"
            :maxlength="30"
            :autofocus="true"
            @change="(e) => (IngredientsCategoryModel.name = e)"
          >
          </TextInput>
        </b-col>
      </b-row>
    </b-card>
    <b-row class="mt-2">
      <b-col cols="12" md="6" class="px-4">
        <div class="d-flex form-status">
          <b-form-checkbox
            :disabled="pageType == 'view'"
            :readonly="pageType == 'view'"
            class="status-switch"
            :checked="IngredientsCategoryModel.status"
            switch
            name="check-button"
            @change="IngredientsCategoryModel.status = $event"
          />
        </div>
      </b-col>
      <b-col cols="12" md="6" class="px-4 text-right">
        <b-button
          class="btn-reset"
          variant="flat-secondary"
          type="button"
          v-if="pageType != 'view'"
          @click="getModelData"
        >
          Reset
        </b-button>
        <b-button
          class="btn-submit-edit"
          v-if="pageType != 'view'"
          variant="primary"
          type="submit"
          :disabled="isSubmit"
        >
          <b-spinner small v-if="isSubmit" />
          Save
        </b-button>
        <b-button
          class="btn-submit-edit"
          v-if="pageType == 'view' && ability.can('read', 'roles_edit')"
          variant="primary"
          type="submit"
          @click.prevent="changeMode(id)"
        >
          <b-spinner small v-if="isSubmit" />
          Edit
        </b-button>
      </b-col>
    </b-row>
  </Form>
</template>
<script>
import {
  BImg,
  BCard,
  BRow,
  BCol,
  BAlert,
  BFormInput,
  BButton,
  BTable,
  BLink,
  BBadge,
  BFormGroup,
  BForm,
  BCardBody,
  BCardHeader,
  BCardFooter,
  BCardTitle,
  BFormCheckbox,
  BFormCheckboxGroup,
  BSpinner,
  BDropdown,
  BDropdownItem,
  BDropdownForm,
  BModal,
} from "bootstrap-vue";
import { useRoute } from "vue-router";
import store from "@/store";
import { ref, onUnmounted, computed, toRaw } from "vue";
import ingredientsCategoryService from "./service";
import Ripple from "vue-ripple-directive";
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import { useToast } from "vue-toastification";
import { Form, useForm, ErrorMessage, Field } from "vee-validate";
import * as yup from "yup";
import ability from "@/libs/acl/ability";
import IngredientsCategoryModel from "./model";

const toast = useToast();

export default {
  components: {
    BImg,
    BCard,
    BRow,
    BCol,
    BAlert,
    BFormInput,
    BButton,
    BTable,
    BLink,
    BBadge,
    BFormGroup,
    BForm,
    BCardHeader,
    BCardTitle,
    BFormCheckbox,
    BCardBody,
    BCardFooter,
    BFormCheckboxGroup,
    BSpinner,
    BDropdown,
    BDropdownItem,
    BDropdownForm,
    BModal,
    Form,
    Field,
    ErrorMessage,
  },
  directives: {
    Ripple,
  },
  setup() {
    const MODULE_NAME = "ingredients-category";

    if (!store.hasModule(MODULE_NAME))
      store.registerModule(MODULE_NAME, ingredientsCategoryService);

    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(MODULE_NAME)) store.unregisterModule(MODULE_NAME);
    });

    return {};
  },
  data() {
    return {
      currentValueSnap: {},
      formLoaded: false,
      pageType: this.$route.meta.type,
      nameasd: "",
      id: "",
      status: "",
      isSubmit: false,
      permissionOptions: [],
      permissionsSelected: [],
      ability,
      IngredientsCategoryModel,
    };
  },
  computed: {
    schema() {
      return yup.object({
        name: yup.string().required("Please enter Role Name"),
        status: yup.boolean(),
      });
    },
  },
  beforeUnmount() {},
  mounted() {
    setTimeout(() => {
      this.formLoaded = true;
    }, 1500);
    const router = useRoute();
    this.id = router?.params?.id;
    this.getModelData();
  },
  methods: {
    currentValue(values) {
      if (!this.formLoaded) {
        this.currentValueSnap = JSON.parse(JSON.stringify(values));
      }
      return "";
    },
    onSubmit(values, { setErrors }) {
      let formData = new FormData();
      formData.append("id", this.IngredientsCategoryModel.id);
      formData.append("name", this.IngredientsCategoryModel.name);
      formData.append("status", this.IngredientsCategoryModel.status);
      this.isSubmit = true;
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      store
        .dispatch("ingredients-category/save", formData)
        .then((response) => {
          if (response.data.status == true) {
            this.$router
              .push({
                name: "ingredients-category-list",
              })
              .then(() => {
                this.showToast(
                  "success",
                  "CheckCircleIcon",
                  response.data.title,
                  response.data.message
                );
                this.isSubmit = false;
              });
          } else {
            if (response.data.errors) {
              setErrors(response.data.errors);
            } else {
              this.showToast(
                "danger",
                "AlertCircleIcon",
                response.data.title,
                response.data.message
              );
            }
            this.isSubmit = false;
          }
          appLoading.style.display = "none";
        })
        .catch(() => {
          this.isSubmit = false;
          appLoading.style.display = "none";
        });
    },
    changeMode(id) {
      this.$router
        .push({ name: "ingredients-category-edit", params: { id: id } })
        .then(() => {
          this.getModelData();
        });
    },
    getModelData() {
      // this.resetForm();
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      if (this.id) {
        this.isEditUser = true;
        const appLoading = document.getElementById("loading-bg");
        if (appLoading) {
          appLoading.style.display = "block";
        }
        store
          .dispatch("ingredients-category/edit", { id: this.id })
          .then((response) => {
            this.pageType = this.$route.meta.type;
            const data = response.data.result;
            this.IngredientsCategoryModel.id = data.id;
            this.IngredientsCategoryModel.ingredients_category_id =
              data.ingredients_category_id;
            this.IngredientsCategoryModel.name = data.name;
            this.IngredientsCategoryModel.status = data.status == 1 ? true : false;
            appLoading.style.display = "none";
          })
          .catch((error) => {
            appLoading.style.display = "none";
          });
      } else {
        this.IngredientsCategoryModel.id = "";
        this.IngredientsCategoryModel.ingredients_category_id = "";
        this.IngredientsCategoryModel.name = "";
        this.IngredientsCategoryModel.status = true;
        appLoading.style.display = "none";
      }
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon,
          text: message,
          variant,
        },
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}
</style>
